module ApplicationHelper
  def full_url filename
    request.protocol + request.host_with_port + filename
  end
  
  def t_m(label)
    l = label.split('.')
    if l.size > 2
      label
    else
      if l.size == 1
        label.constantize.model_name.human
      else
        l.first.constantize.human_attribute_name(l.last)
      end
    end
  end
  
  def t_select_items(items)
    items.map {|i| [t(i[0]), i[1]] }
  end
  
  def t_selected_item(name, index)
    t(MagicNumber[name][index][0])
  end
  
  def icon_tag name, opt = {}
    title = opt[:object] ? (name.to_s + ' ID:' + opt[:object].id.to_s) : name
    size = opt[:size] ? opt[:size].to_i : 35
    tag :img, :src => asset_path(name.to_s.downcase + '.gif'), :width => size, :height => size, :alt => name.to_s + ' Icon', :title => title
  end
  
  def author_icon opt = {}
    icon_tag :Author, opt
  end
  
  def artist_icon opt = {}
    icon_tag :Artist, opt
  end
  
  def comic_icon opt = {}
    icon_tag :Comic, opt
  end
  
  def story_icon opt = {}
    icon_tag :Story, opt
  end
  
  def panel_icon opt = {}
    icon_tag :Panel, opt
  end
  
end
